﻿TMisd = LibStub("AceAddon-3.0"):NewAddon("TMisd", "AceHook-3.0", "AceEvent-3.0", "AceTimer-3.0");
local TMisd = TMisd;
local config = LibStub("AceConfig-3.0")
local dialog = LibStub("AceConfigDialog-3.0")
local TMButtonTxt = {{"Misdirection 1"},{"Misdirection 2"},{"Misdirection 3"},{},{},{},{},{},{},{}}
local TMisdButtons = {};
local TMisdMenu = {};
local class_colors = { ["HUNTER"] = "ABD473",["WARLOCK"] = "9482C9",["PRIEST"] = "FFFFFF",["PALADIN"] = "F58CBA",["MAGE"] = "69CCF0",["ROGUE"] = "FFF569",["DRUID"] = "FF7D0A",["SHAMAN"] = "0070DE",["WARRIOR"] = "C79C6E",["DEATHKNIGHT"] = "C41F3B" }

function TMisd:OnInitialize()
	local defaults = {
		  profile = {
			numMacros ={1,1,1,1,1,1,1,1,1,1},
			macroid = {
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},
				{"","","","","","","","","","",""},	
			},
			announce = {false,false,false,false,false,false,false,false,false,false},
			announceTo = {"PARTY","PARTY","PARTY","PARTY","PARTY","PARTY","PARTY","PARTY","PARTY","PARTY","PARTY"},
			ora = {false,false,false,false,false,false,false,false,false,false},
			lfg = {false,false,false,false,false,false,false,false,false,false},
			custom = {false,false,false,false,false,false,false,false,false,false},
			btank = {false,false,false,false,false,false,false,false,false,false},
			pet = {false,false,false,false,false,false,false,false,false,false},
			macroicon ={
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1},
				{1,1,1,1,1,1,1,1,1,1}
			},
			skills = {"","","","","","","","","",""},
			inuse = {true,false,false,false,false,false,false,false,false,false}
		  }
		}
		
	self.db = LibStub("AceDB-3.0"):New("TMisdDB", defaults)
	TMisd:SecureHook(GameTooltip, "SetAction", self.TMisdSetTooltip)
end

--Tooltips
function TMisd:TMisdSetTooltip(arg1)
	mname = GetActionText(arg1)
	if(mname)then
		str1,str2,str3 = strsplit("_", mname)
		if(str1 and str2 and str3)then
			for i=1,10 do
				if ( str2 == TMisd.db.profile.skills[i] )then
					_,class = UnitClass(str1);
					if (class==nil) then class = "PRIEST" end
					GameTooltip:AddLine(format("target = |cFF%s%s|r",class_colors[class],str1),1,1,1)	
					GameTooltip:Show()
				end
			end
		end
	end
end

	--local temp1=GetNumMacroIcons()	
	local vMacroIcons = {INV_MISC_QUESTIONMARK}
	GetMacroItemIcons(vMacroIcons)
	GetMacroIcons(vMacroIcons)
	local temp1 = #vMacroIcons
	
--function to alter macros
function TMisd:Alter_Macro(name,spec,nr)
	if InCombatLockdown()==nil then
		local icon
		if ( self.db.profile.custom[spec] ) then
			icon=self.db.profile.macroicon[spec][nr]
		else icon = 4385 end
		name = string.gsub(name, " (*)", "");
		EditMacro(self.db.profile.macroid[spec][nr], format("%s_%s_%i", name, self.db.profile.skills[spec], nr), vMacroIcons[icon], format("#showtooltip\n/use [@%s] %s", name, self.db.profile.skills[spec]),1)
		self.db.profile.macroid[spec][nr]=format("%s_%s_%i", name, self.db.profile.skills[spec], nr)
		TMButtonTxt[spec][nr] = self.db.profile.macroid[spec][nr]
		local buttoncnt = 1
		for j=1,10 do
			if (self.db.profile.inuse[j]) then
				for i=1,self.db.profile.numMacros[j] do
					local temp = format("%i_%i", j,i)
					TMisdButtons[temp] = {text=TMButtonTxt[j][i], dist=0, color="|cffffffff", tooltipText=""};
					TMisdMenu[buttoncnt] = temp;
					buttoncnt = buttoncnt + 1
				end
			end
		end
		TMisdMenu[buttoncnt] = nil
		local _,class = UnitClass(name);
		DEFAULT_CHAT_FRAME:AddMessage(format("|cff33ff99TMisd|r: %s Macro %i target = |cFF%s%s|r", self.db.profile.skills[spec], nr, class_colors[class], name))
	end
end

--alter macro on entering rnd dungeon 
 function TMisd:PLAYER_ROLES_ASSIGNED()
	_,instanceType = IsInInstance()
	if (GetNumPartyMembers()==0 or instanceType~="party") then return; end
	local failed = true
	for i=1, 4 do
		if ((UnitGroupRolesAssigned("Party"..i)=="TANK") and not(un==UnitName("Party"..i))) then
			for j=1, 10 do
				if (self.db.profile.inuse[j] and self.db.profile.lfg[j]) then
					TMisd:Alter_Macro(UnitName(format("Party"..i)), j, 1)
					failed=false
				end
			end
		end
	end
	if ( failed==true ) then
		TMisd:CancelAllTimers()
		TMisd:ScheduleTimer("PLAYER_ROLES_ASSIGNED", 2)
		return;
	end	
end

--alter macro on ora2 mt change
function TMisd:CHAT_MSG_ADDON(event,pre,msg,dist,snd)
	for j=1, 10 do
		if ( self.db.profile.ora[j] ) then
			if ( pre=="oRA" or pre=="CTRA" )then
				local str1,str2,str3 = strsplit(" ", msg)
				if (str1=="SET") then
					local nametemp = strsplit("_", self.db.profile.macroid[j][tonumber(str2)])
					if ( str1=="SET" and tonumber(str2) <= self.db.profile.numMacros[j] and str3~=nametemp) then
						TMisd:Alter_Macro(str3,j,tonumber(str2))
					end
				end
			end
		end
	end
end

--"name" already in use (for Blizz MT)
function TMisd:MacroIdContains(i,name)
	for j=1,10 do
		if (name==strsplit("_", self.db.profile.macroid[i][j])) then
			return j;
		end
	end
	return false;
end

--auto pet when not in party
function TMisd:PARTY_MEMBERS_CHANGED()
	if(HasPetSpells())then
		local name=strsplit("_", self.db.profile.macroid[1][1])
		name=string.gsub(name, " (*)", "");
		if (GetNumPartyMembers()==0 and not(UnitName("pet")==name)) then TMisd:Alter_Macro(UnitName("pet"), 1, 1) end
	end
end

--alter macro on Blizz MT change
function TMisd:RAID_ROSTER_UPDATE()	
	for j=1, 10 do
		if ( self.db.profile.btank[j] ) then
			local tank={}
			tank[1],tank[2],tank[3],tank[4],tank[5],tank[6],tank[7],tank[8],tank[9],tank[10] = GetPartyAssignment("maintank")
			local inuse = {false,false,false,false,false,false,false,false,false,false}
			local i=1
			while (tank[i]~=nil) do
				temp = TMisd:MacroIdContains(j,GetUnitName("raid"..tank[i]))
				if (temp) then
					inuse[temp]=true
				end
				i=i+1
			end
			i=1
			while (tank[i]~=nil and self.db.profile.numMacros[j] >= i) do
				if( not TMisd:MacroIdContains(j,GetUnitName("raid"..tank[i])) ) then
					for k=1,10 do
						if (not inuse[k] and self.db.profile.numMacros[j] >= k) then
							TMisd:Alter_Macro(GetUnitName("raid"..tank[i]),j,k)
							break
						end
					end
				end
				i=i+1
			end 
		end
	end
end

--announce
function TMisd:COMBAT_LOG_ON()
	TMisd:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function TMisd:COMBAT_LOG_EVENT_UNFILTERED(_,_, subEvent, sourceGUID, _, _, _, destName, _, spellId,spellName)
	if sourceGUID == UnitGUID('player') and (subEvent=="SPELL_CAST_SUCCESS" or subEvent=="SPELL_HEAL" or subEvent=="SPELL_AURA_APPLIED")then
		if (spellId==35079 or spellId==379 or(spellId==34477 and subEvent=="SPELL_AURA_APPLIED")) then
			return
		end
		
		for i=1,10 do
			if (self.db.profile.announce[i] and self.db.profile.skills[i]==GetSpellInfo(spellId)) then
				chan, nr = strsplit(" ", self.db.profile.announceTo[i])	
				if (chan=="CHANNEL") then
					SendChatMessage(format("%s %s!",spellName,destName), chan, nil, nr)
				elseif (chan ~= "smart") then
					SendChatMessage(format("%s %s!",spellName,destName), chan, nil, destName)
				else
					if GetNumRaidMembers() > 0 then
						SendChatMessage(format("%s %s!",spellName,destName), 'RAID')
					elseif GetNumPartyMembers() > 0 then
						SendChatMessage(format("%s %s!",spellName,destName), 'PARTY')
					end
				end
				TMisd:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
				TMisd:CancelAllTimers()
				TMisd:ScheduleTimer("COMBAT_LOG_ON", 1)
			end
		end		
	end
end

--Error ausgabe zu viele makros
	function TMisd:MacroOverflow()
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99TMisd WARNING|r: You reached the maximum number of Macros")
		DEFAULT_CHAT_FRAME:AddMessage("--- no new macro added! ---")
	end
	
--apply settings
function TMisd:ApplySettings(spec)
	if (self.db.profile.inuse[spec]) then
		local name, texture, macrobody
		local str1,str2,str3	
			--Macro anzahl verringern wenn zuviele
			for i=(self.db.profile.numMacros[spec] + 1),10 do
				if GetMacroBody(self.db.profile.macroid[spec][i]) then DeleteMacro(self.db.profile.macroid[spec][i]) end
				self.db.profile.macroid[spec][i]= "";
			end
			--Macros erkennen die vorhanden sind aber dem addon nicht bekannt
			for i=37 , 54 do
				name = GetMacroInfo(i)
				str1,str2,str3 = nil,nil,nil
				if name~=nil then str1,str2,str3 = strsplit("_", name) end
				if ( str2 == self.db.profile.skills[spec] ) then
						if ( tonumber(str3)~=nil and name~=self.db.profile.macroid[spec][tonumber(str3)] and tonumber(str3)<=10 and tonumber(str3) >=1 ) then
							self.db.profile.macroid[spec][tonumber(str3)] = name
						end
				elseif ( str1 == self.db.profile.skills[spec] )  then
						if ( tonumber(str2)~=nil and name~=self.db.profile.macroid[spec][tonumber(str2)] and str3 == nil and tonumber(str2)<=10 and tonumber(str2) >=1 ) then
							self.db.profile.macroid[spec][tonumber(str2)] = name
						end
				end
			end
			--Macros Erstellen die dem Addon bekannt sind aber nicht vorhanden
			for i=1, self.db.profile.numMacros[spec] do	
				if self.db.profile.macroid[spec][i] == "" then
					local icon
					if ( self.db.profile.custom[spec] ) then
						icon=self.db.profile.macroicon[spec][i]
					else icon = 4385 end
					self.db.profile.macroid[spec][i]=format("%s_%i", self.db.profile.skills[spec], i)
					CreateMacro(self.db.profile.macroid[spec][i], vMacroIcons[icon], format("#showtooltip\n/use %s", self.db.profile.skills[spec]), 1);	
				elseif (GetMacroBody(self.db.profile.macroid[spec][i])==nil) then
					local icon
					if ( self.db.profile.custom[spec] ) then
						icon=self.db.profile.macroicon[spec][i]
					else icon = 4385 end
					CreateMacro(self.db.profile.macroid[spec][i], vMacroIcons[icon], format("#showtooltip\n/use  %s", self.db.profile.skills[spec]), 1)
				else TMButtonTxt[spec][i] = self.db.profile.macroid[spec][i] end
			end

			--Alle Macros neu schreiben
			for i=1, self.db.profile.numMacros[spec] do
				local icon
				if ( self.db.profile.custom[spec] ) then
					icon=self.db.profile.macroicon[spec][i]
				else icon = 4385 end
				name = strsplit("_", self.db.profile.macroid[spec][i])
				name = string.gsub(name, " (*)", "");
				if ( name~=self.db.profile.skills[spec] )then
					EditMacro(self.db.profile.macroid[spec][i], format("%s_%s_%i", name, self.db.profile.skills[spec], i), vMacroIcons[icon], format("#showtooltip\n/use [@%s] %s", name, self.db.profile.skills[spec]),1)
				elseif ( name==self.db.profile.skills[spec] ) then
					EditMacro(self.db.profile.macroid[spec][i], format("%s_%i", self.db.profile.skills[spec], i), vMacroIcons[icon], format("#showtooltip\n/use %s", self.db.profile.skills[spec]),1)
				end
			end
	--bei spec delete alle Macros der spec deleten
	elseif (self.db.profile.skills[spec] ~= "") then
		for i=1,self.db.profile.numMacros[spec] do
				if GetMacroBody(self.db.profile.macroid[spec][i]) then DeleteMacro(self.db.profile.macroid[spec][i]) end
				self.db.profile.macroid[spec][i]= "";
		end
	end
	
	--Menü aufräumen
	local buttoncnt = 1
	for j=1,10 do
		if (self.db.profile.inuse[j]) then
			for i=1,self.db.profile.numMacros[j] do
				local temp = format("%i_%i", j,i)
				TMisdButtons[temp] ={text=TMButtonTxt[j][i], dist=0, color="|cffffffff", tooltipText=""};
				TMisdMenu[buttoncnt] = temp;
				buttoncnt = buttoncnt + 1
			end
		end
	end
	TMisdMenu[buttoncnt] = nil
end

--addon start (/w options,getter,setter)
function TMisd:OnEnable()

	if (GetLocale() == "deDE") then
		md= "Irref\195\188hrung"
		un= "Unbekannt"
	elseif (GetLocale() == "enUS" or GetLocale() == "enGB") then
		md= "Misdirection"
		un= "Unknown"
	elseif (GetLocale() == "esES" or GetLocale() == "esMX") then
		md= "Redirecci\195\179n"
		un= "Desconocido"
	elseif (GetLocale() == "frFR") then
		md= "D\195\169tournement"
		un= "Inconnu"
	elseif (GetLocale() == "ruRU") then
		md= "Перенаправление"
		un= "Неизвестно"
	else
		md= "Misdirection"
		un= "Unknown"
	end
	self.db.profile.skills[1]=md
	
	self:SecureHook("UnitPopup_ShowMenu");
	--options
	
	local function SetArrayValue(info, value)
		info.handler.db.profile[info[#info]][tonumber(info.arg)] = value
		self:ApplySettings(tonumber(info.arg))
		if ( info[#info]=="lfg" ) then
			if (value) then
				TMisd:RegisterEvent("PLAYER_ROLES_ASSIGNED")
			else
				if ( not(info.handler.db.profile.lfg[1] or
					 info.handler.db.profile.lfg[2] or
					 info.handler.db.profile.lfg[3] or
					 info.handler.db.profile.lfg[4] or
					 info.handler.db.profile.lfg[5] or
					 info.handler.db.profile.lfg[6] or
					 info.handler.db.profile.lfg[7] or
					 info.handler.db.profile.lfg[8] or
					 info.handler.db.profile.lfg[9] or
					 info.handler.db.profile.lfg[10] )
				) then
					TMisd:UnregisterEvent("PLAYER_ROLES_ASSIGNED")
				end
			end
		elseif ( info[#info]=="ora" ) then
			if (value) then
				TMisd:RegisterEvent("CHAT_MSG_ADDON")
			else
				if ( not(info.handler.db.profile.ora[1] or
					 info.handler.db.profile.ora[2] or
					 info.handler.db.profile.ora[3] or
					 info.handler.db.profile.ora[4] or
					 info.handler.db.profile.ora[5] or
					 info.handler.db.profile.ora[6] or
					 info.handler.db.profile.ora[7] or
					 info.handler.db.profile.ora[8] or
					 info.handler.db.profile.ora[9] or
					 info.handler.db.profile.ora[10] )
				) then
					TMisd:UnregisterEvent("CHAT_MSG_ADDON")
				end
			end
		elseif ( info[#info]=="announce" ) then
			if (value) then
				TMisd:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			else
				if ( not(info.handler.db.profile.announce[1] or
					 info.handler.db.profile.announce[2] or
					 info.handler.db.profile.announce[3] or
					 info.handler.db.profile.announce[4] or
					 info.handler.db.profile.announce[5] or
					 info.handler.db.profile.announce[6] or
					 info.handler.db.profile.announce[7] or
					 info.handler.db.profile.announce[8] or
					 info.handler.db.profile.announce[9] or
					 info.handler.db.profile.announce[10] )
				) then
					TMisd:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
				end
			end
		elseif ( info[#info]=="pet" ) then
			if (value) then
				TMisd:RegisterEvent("PARTY_MEMBERS_CHANGED")
				local name=strsplit("_", self.db.profile.macroid[1][1])
				name=string.gsub(name, " (*)", "");
				if (GetNumPartyMembers()==0 and not(UnitName("pet")==name)) then TMisd:Alter_Macro(UnitName("pet"), 1, 1) end
			else
				if(	not(info.handler.db.profile.pet[1] or
					 info.handler.db.profile.pet[2] or
					 info.handler.db.profile.pet[3] or
					 info.handler.db.profile.pet[4] or
					 info.handler.db.profile.pet[5] or
					 info.handler.db.profile.pet[6] or
					 info.handler.db.profile.pet[7] or
					 info.handler.db.profile.pet[8] or
					 info.handler.db.profile.pet[9] or
					 info.handler.db.profile.pet[10])
				) then
					TMisd:UnregisterEvent("PARTY_MEMBERS_CHANGED")
				end
			end
		elseif ( info[#info]=="btank" or info[#info]=="pet") then
			if (value) then
				TMisd:RegisterEvent("RAID_ROSTER_UPDATE")
			else
				if ( not(info.handler.db.profile.btank[1] or
					 info.handler.db.profile.btank[2] or
					 info.handler.db.profile.btank[3] or
					 info.handler.db.profile.btank[4] or
					 info.handler.db.profile.btank[5] or
					 info.handler.db.profile.btank[6] or
					 info.handler.db.profile.btank[7] or
					 info.handler.db.profile.btank[8] or
					 info.handler.db.profile.btank[9] or
					 info.handler.db.profile.btank[10] )
				) then
					TMisd:UnregisterEvent("RAID_ROSTER_UPDATE")
				end
			end
		end
		
	end
	
	local function GetArrayValue(info)
		value = info.handler.db.profile[info[#info]][tonumber(info.arg)]
		if ( info[#info]=="lfg" ) then
			if (value) then
				TMisd:RegisterEvent("PLAYER_ROLES_ASSIGNED")
			else
				if ( not(info.handler.db.profile.lfg[1] or
					 info.handler.db.profile.lfg[2] or
					 info.handler.db.profile.lfg[3] or
					 info.handler.db.profile.lfg[4] or
					 info.handler.db.profile.lfg[5] or
					 info.handler.db.profile.lfg[6] or
					 info.handler.db.profile.lfg[7] or
					 info.handler.db.profile.lfg[8] or
					 info.handler.db.profile.lfg[9] or
					 info.handler.db.profile.lfg[10] )
				) then
					TMisd:UnregisterEvent("PLAYER_ROLES_ASSIGNED")
				end
			end
		elseif ( info[#info]=="pet" ) then
			if (value) then
				TMisd:RegisterEvent("PARTY_MEMBERS_CHANGED")
				local name=strsplit("_", self.db.profile.macroid[1][1])
				name=string.gsub(name, " (*)", "");
				if (GetNumPartyMembers()==0 and not(UnitName("pet")==name)) then TMisd:Alter_Macro(UnitName("pet"), 1, 1) end
			else
				if(	not(info.handler.db.profile.pet[1] or
					 info.handler.db.profile.pet[2] or
					 info.handler.db.profile.pet[3] or
					 info.handler.db.profile.pet[4] or
					 info.handler.db.profile.pet[5] or
					 info.handler.db.profile.pet[6] or
					 info.handler.db.profile.pet[7] or
					 info.handler.db.profile.pet[8] or
					 info.handler.db.profile.pet[9] or
					 info.handler.db.profile.pet[10])
				) then
					TMisd:UnregisterEvent("PARTY_MEMBERS_CHANGED")
				end
			end
		elseif ( info[#info]=="ora" ) then
			if (value) then
				TMisd:RegisterEvent("CHAT_MSG_ADDON")
			else
				if ( not(info.handler.db.profile.ora[1] or
					 info.handler.db.profile.ora[2] or
					 info.handler.db.profile.ora[3] or
					 info.handler.db.profile.ora[4] or
					 info.handler.db.profile.ora[5] or
					 info.handler.db.profile.ora[6] or
					 info.handler.db.profile.ora[7] or
					 info.handler.db.profile.ora[8] or
					 info.handler.db.profile.ora[9] or
					 info.handler.db.profile.ora[10] )
				) then
					TMisd:UnregisterEvent("CHAT_MSG_ADDON")
				end
			end
		elseif ( info[#info]=="announce" ) then
			if (value) then
				TMisd:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			else
				if ( not(info.handler.db.profile.announce[1] or
					 info.handler.db.profile.announce[2] or
					 info.handler.db.profile.announce[3] or
					 info.handler.db.profile.announce[4] or
					 info.handler.db.profile.announce[5] or
					 info.handler.db.profile.announce[6] or
					 info.handler.db.profile.announce[7] or
					 info.handler.db.profile.announce[8] or
					 info.handler.db.profile.announce[9] or
					 info.handler.db.profile.announce[10] )
				) then
					TMisd:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
				end
			end
		elseif ( info[#info]=="btank" or info[#info]=="pet") then
			if (value) then
				TMisd:RegisterEvent("RAID_ROSTER_UPDATE")
			else
				if ( not(info.handler.db.profile.btank[1] or
					 info.handler.db.profile.btank[2] or
					 info.handler.db.profile.btank[3] or
					 info.handler.db.profile.btank[4] or
					 info.handler.db.profile.btank[5] or
					 info.handler.db.profile.btank[6] or
					 info.handler.db.profile.btank[7] or
					 info.handler.db.profile.btank[8] or
					 info.handler.db.profile.btank[9] or
					 info.handler.db.profile.btank[10])
				) then
					TMisd:UnregisterEvent("RAID_ROSTER_UPDATE")
				end
			end
		end
		return value
	end
	
	local function SetNewSkill(info, value)
		for i=1,10 do
			if (info.handler.db.profile.skills[i]== value) then
				DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99TMisd WARNING|r:TMisd can only handle each skill once")
				DEFAULT_CHAT_FRAME:AddMessage("--- no new skill added! ---")
				return
			end
		end
		for i=1,10 do
			if(not info.handler.db.profile.inuse[i]) then
				info.handler.db.profile.inuse[i]= true
				info.handler.db.profile.skills[i]= value
				local specifics = info.options.args["Skillspecifics"..tostring(i)]
				specifics.name = value
				specifics.hidden = false
				specifics.name = value
				self:ApplySettings(i)
				self:ApplySettings(i)
				break
			end
			if(i==10) then
				DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99TMisd WARNING|r: TMisd can only handle up to 10 different skills at once")
				DEFAULT_CHAT_FRAME:AddMessage("--- no new skill added! ---")
			end
		end
	end
	
	local function GetNewSkill(info)
			for i=1,10 do
				if(info.handler.db.profile.inuse[i]) then
					local specifics = info.options.args["Skillspecifics"..tostring(i)]
					specifics.name = info.handler.db.profile.skills[i]
					specifics.hidden = false
				end
			end
		return nil
	end
	
	local function deletespecifics(info)
		local i = tonumber(info.arg)
		test= info.options.args["Skillspecifics"..info.arg]
		test.hidden = true
		info.handler.db.profile.inuse[i] = false
		self:ApplySettings(i)
		info.handler.db.profile.macroid[i] = {"","","","","","","","","","",""}
		info.handler.db.profile.announce[i] = false
		info.handler.db.profile.announceTo[i] = "PARTY"
		info.handler.db.profile.ora[i] = false
		info.handler.db.profile.lfg[i] = false 
		info.handler.db.profile.btank[i] = false 
		info.handler.db.profile.custom[i] = false
		info.handler.db.profile.macroicon[i] = {1,1,1,1,1,1,1,1,1,1}
		info.handler.db.profile.skills[i] = ""
		info.handler.db.profile.numMacros[i] = 1
	end
	
	local function GetnumMacros(info)
		local value = info.handler.db.profile[info[#info]][tonumber(info.arg)]
		local specifics = info.options.args["Skillspecifics"..info.arg]
			for i=1,10 do
				local thisspecifics = specifics.args["macroicon"..tostring(i)]
				if (i<=value)then
					thisspecifics.hidden=false
				else
					thisspecifics.hidden=true
				end
			end
		return value
	end
		
	local function SetnumMacros(info, value)
		local _,numperchar = GetNumMacros()
		if (numperchar==18 and info.handler.db.profile[info[#info]][tonumber(info.arg)] < value) then
				TMisd:CancelAllTimers()
				TMisd:ScheduleTimer("MacroOverflow", 1)
			return;
		end
		info.handler.db.profile[info[#info]][tonumber(info.arg)]= value
		local specifics = info.options.args["Skillspecifics"..info.arg]
	
		for i=1,10 do
			local thisspecifics = specifics.args["macroicon"..tostring(i)]
			if (i<=value)then
				thisspecifics.hidden=false
			else
				thisspecifics.hidden=true
			end
		end
		self:ApplySettings(tonumber(info.arg))
	end

	local function SetCustom(info, value)
		info.handler.db.profile[info[#info]][tonumber(info.arg)] = value
		local specifics = info.options.args["Skillspecifics"..info.arg]
		for i=1,10 do
			local thisspecifics = specifics.args["macroicon"..tostring(i)]
			thisspecifics.disabled=not value
		end
		self:ApplySettings(tonumber(info.arg))
	end
	
	local function GetCustom(info)
		local value = info.handler.db.profile[info[#info]][tonumber(info.arg)]
		local specifics = info.options.args["Skillspecifics"..info.arg]
		for i=1,10 do
			local thisspecifics = specifics.args["macroicon"..tostring(i)]
			thisspecifics.disabled=not value
		end		
		return value
	end
	
	local function SetIcon(info, value)
		local specifics = info.options.args["Skillspecifics"..info.arg].args[info[#info-1]]
		info.handler.db.profile.macroicon[tonumber(info.arg)][specifics.order] = value
		specifics.args.icon.image=vMacroIcons[value]
		self:ApplySettings(tonumber(info.arg))
	end
	
	local function GetIcon(info)
		local specifics = info.options.args["Skillspecifics"..info.arg].args[info[#info-1]]
		return info.handler.db.profile.macroicon[tonumber(info.arg)][specifics.order]
	end
	
		
	options = {
		name = "Tyra Misdirect",
		type = 'group',
		childGroups  = 'tab',
		handler = TMisd,
		get = GetArrayValue,
		set = SetArrayValue,
		args = {
				Skillspecifics1={
				name = md,
				type = 'group',
				order = 11,
				childGroups  = 'tab',
				args = {
						numMacros = {
							name = "Macros",
							desc = "Numbers of Macros you want TyraMisdirect to create and handle",
							order = 2,
							type = "range",
							arg = "1",
							get = GetnumMacros,
							set = SetnumMacros,
							min = 1, max = 10, step = 1,
						},
						anounceheader= {
							name = "Announce",
							order = 3,
							type = "header",
						},
						announce = {
							name = "Announce",
							desc = "Announce Cast to selected channel",
							order = 4,	
							type = "toggle",
							arg = "1",
						},
						announceTo = {
							name = "Announce to",
							desc = "Announce Cast to selected channel",
							order = 5,
							type = "select",
							values = {["OFFICER"] = "officers", ["GUILD"] = "guild", ["RAID_WARNING"] = "raidwarning", ["RAID"] = "raid", ["YELL"] = "yell", ["PARTY"] = "party", ["SAY"] = "say", ["WHISPER"] = "whisper",
							["BATTLEGROUND"] = "battleground", ["CHANNEL 5"]= "Channel 5", ["CHANNEL 6"]= "Channel 6", ["CHANNEL 7"]= "Channel 7", ["CHANNEL 8"]= "Channel 8", ["CHANNEL 9"]= "Channel 9", ["smart"]= "smart"},
							arg = "1",
						},
						autoheader= {
							name = "Automations",
							order = 6,
							type = "header",
						},
						lfg = {
							name = "Dungeon Finder Tank",
							desc = "will set the Tank of the random group to Macro 1 automatically",
							order = 7,
							type = "toggle",
							arg = "1",
						},
						btank = {
							name = "Blizzard Maintank",
							desc = "will set the Blizzard Maintank on Macro 1-10 automatically",
							order = 8,
							type = "toggle",
							arg = "1",
						},
						ora = {
							name = "oRA/CTRA Tank",
							desc = "will set the oRA/CTRA Tanks on Macro 1-10 automatically",
							order = 9,
							type = "toggle",
							arg = "1",
						},
						pet = {
							name = "Pet",
							desc = "will set your Pet to Macro 1 automatically when not in group",
							order = 10,
							type = "toggle",
							arg = "1",
						},
						skillheader= {
							name = "Custom icons",
							order = 11,
							type = "header",
						},
						custom = {
							name = "Use custom Icons",
							desc = "Use custom Icons for Macros",
							order = 13,
							type = "toggle",
							get = GetCustom,
							set = SetCustom,
							arg = "1",
						},
						macroicon1 = {
							name = "Macro 1 Icon",
							type = 'group',
							order=1,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][1]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon2 = {
							name = "Macro 2 Icon",
							type = 'group',
							order=2,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][2]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon3 = {
							name = "Macro 3 Icon",
							type = 'group',
							order=3,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][3]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon4 = {
							name = "Macro 4 Icon",
							type = 'group',
							order=4,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][4]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon5 = {
							name = "Macro 5 Icon",
							type = 'group',
							order=5,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][5]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon6 = {
							name = "Macro 6 Icon",
							type = 'group',
							order=6,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][6]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon7 = {
							name = "Macro 7 Icon",
							type = 'group',
							order=7,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][7]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon8 = {
							name = "Macro 8 Icon",
							type = 'group',
							order=8,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][8]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon9 = {
							name = "Macro 9 Icon",
							type = 'group',
							order=9,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][9]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
						macroicon10 = {
							name = "Macro 10 Icon",
							type = 'group',
							order=10,
							args = {
									icon = {
										name = "",
										order= 20,
										image = vMacroIcons[self.db.profile.macroicon[1][10]],
										type = 'execute',
										width = "half"
									},
									iconselect = {
										name = "Icon Index",
										type = "range",
										order= 10,
										arg = "1",
										set = SetIcon,
										get = GetIcon,
										min = 1, max = temp1, step = 1
									},		
							}
						},
					},
				},
			}
	}
	
	config:RegisterOptionsTable("TyraMisdirect", options)
	dialog:AddToBlizOptions("TyraMisdirect", "TyraMisdirect")
	LibStub("AceConfigRegistry-3.0"):NotifyChange("TyraMisdirect");
	
	for i=1,10 do
		self:ApplySettings(i)
	end
	if (self.db.profile.lfg[1] or
		self.db.profile.lfg[2] or
		self.db.profile.lfg[3] or
		self.db.profile.lfg[4] or
		self.db.profile.lfg[5] or
		self.db.profile.lfg[6] or
		self.db.profile.lfg[7] or
		self.db.profile.lfg[8] or
		self.db.profile.lfg[9] or
		self.db.profile.lfg[10] 
	) then
		TMisd:RegisterEvent("PLAYER_ROLES_ASSIGNED")
	end
	if (self.db.profile.ora[1] or
		self.db.profile.ora[2] or
		self.db.profile.ora[3] or
		self.db.profile.ora[4] or
		self.db.profile.ora[5] or
		self.db.profile.ora[6] or
		self.db.profile.ora[7] or
		self.db.profile.ora[8] or
		self.db.profile.ora[9] or
		self.db.profile.ora[10] 
	) then
		TMisd:RegisterEvent("CHAT_MSG_ADDON")
	end
	if (self.db.profile.announce[1] or
		self.db.profile.announce[2] or
		self.db.profile.announce[3] or
		self.db.profile.announce[4] or
		self.db.profile.announce[5] or
		self.db.profile.announce[6] or
		self.db.profile.announce[7] or
		self.db.profile.announce[8] or
		self.db.profile.announce[9] or
		self.db.profile.announce[10] 
	) then
		TMisd:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
	if (self.db.profile.btank[1] or
		self.db.profile.btank[2] or
		self.db.profile.btank[3] or
		self.db.profile.btank[4] or
		self.db.profile.btank[5] or
		self.db.profile.btank[6] or
		self.db.profile.btank[7] or
		self.db.profile.btank[8] or
		self.db.profile.btank[9] or
		self.db.profile.btank[10]
	) then
		TMisd:RegisterEvent("RAID_ROSTER_UPDATE")
	end
	if(
		self.db.profile.pet[1] or
		self.db.profile.pet[2] or
		self.db.profile.pet[3] or
		self.db.profile.pet[4] or
		self.db.profile.pet[5] or
		self.db.profile.pet[6] or
		self.db.profile.pet[7] or
		self.db.profile.pet[8] or
		self.db.profile.pet[9] or
		self.db.profile.pet[10] 
	) then
		TMisd:RegisterEvent("PARTY_MEMBERS_CHANGED")
		local name=strsplit("_", self.db.profile.macroid[1][1])
		name=string.gsub(name, " (*)", "");
		if (GetNumPartyMembers()==0 and not(UnitName("pet")==name)) then TMisd:Alter_Macro(UnitName("pet"), 1, 1) end
	end
end

-- TMisd Button clicked
local function TMisd_Button_Onclick(self, info)
	assert(info);
	local button = info.button; assert(button);
	local name = info.name or UnitName(info.unit); assert(name);
	specific,numMacro = strsplit("_", button)
	TMisd:Alter_Macro(name,tonumber(specific),tonumber(numMacro));
	--assuming button names "1-1" - "10-10"
end

-- draw context menu
function TMisd:UnitPopup_ShowMenu(dropdownMenu, which, unit, name, userData)
	if (InCombatLockdown()==nil and unit ~=nil) then
		local thisName = name or UnitName(unit);
		which = gsub(which, "PB4_", "");
		if ((not UnitPlayerOrPetInRaid(unit)) and (not UnitPlayerOrPetInParty(unit)) and ( not UnitIsUnit(unit, "pet")) ) then return; end
		if (UIDROPDOWNMENU_MENU_LEVEL > 1) then return; end
		local info = UIDropDownMenu_CreateInfo();
		for _,v in ipairs(TMisdMenu) do
			info.text=TMisdButtons[v].text;
			info.value=v;
			info.owner=which;
			info.func=TMisd_Button_Onclick;
			info.notCheckable=1;
			info.arg1 = {["button"]=v, ["unit"]=unit, ["name"]=name};
			info.tooltipTitle = TMisdButtons[v].text;
			info.tooltipText = TMisdButtons[v].tooltipText;
			UIDropDownMenu_AddButton(info)
		end
	end
end